﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

// Tarvitsemme Unityn UI-resurssit käsitelläksemme UI-komponentteja
using UnityEngine.UI;

public class Aika : MonoBehaviour {

    // Viittaus peliruudun aikailmaisintekstiin tallennetaan tähän muuttujaan inspektorin kautta.
    public Text teksti;

    // Jotta tiedämme, milloin sekunti on kulunut, täytyy meidän tallentaa edellisten sekuntien määrä.
    int viimeAika;
	
	void Update () {
        // Katsotaan jokaisella Update-funktion kutsulla, mikäli sekunti on kulunut. Tämä onnistuu pyöristämällä
        // Time.timeSinceLeveLoad-arvo alaspäin, jolloin saamme tasasekunteina ajan, joka on kulunut siitä kun taso ladattiin.
        int nykyinenAika = Mathf.FloorToInt(Time.timeSinceLevelLoad);

        // Mikäli tällä Update-funktion kutsulla kulunut aika sekunteina ei vastaa viimeAika-muuttujan arvoa, on kulunut sekunti.
        if (nykyinenAika != viimeAika)
        {
            // Asetetaan peliruudulla näkyvän pistetekstin tekstiksi kulunut aika muutettuna haluttuun muotoon, esim 06:19.
            teksti.text = muunnaTekstiksi(nykyinenAika);

            // Lopuksi asetetaan viimeAika-muuttujan arvoksi nykyisten kuluneiden sekuntien määrä.
            viimeAika = nykyinenAika;
        }
	}

    // Tämä funktio muuttaa ajan sekunteina luettavampaan muotoon.
    private string muunnaTekstiksi(int aika)
    {
        // Kuluneet tunnit saadaan jakamalla sekunnit 3600, sillä tunnissa on 3600 sekuntia.
        int tunnit = aika / 3600;

        // Nykyisestä vajaasta tunnista saadaan kuluneet minuutit jakamalla kuluneiden sekuntien määrän modulo 3600 luvulla 60.
        // Kuluneiden sekuntien määrä modulo 3600 palauttaa siis sekunnit, jotka on kuluneet nykyisestä vajaasta tunnista.
        // Tämä jaetaan luvulla 60, koska minuutissa on 60 sekuntia. 
        int minuutit = (aika % 3600) / 60;

        // Nykyisen vajaan minuutin kuluneet sekunnit saadaan laskemalla kuluneiden sekuntien modulo 60, koska minuutissa on 60 sekuntia.
        int sekunnit = aika % 60;

        // Jos pelaaja on pelannut peliä yli tunnin, tahdomme näyttää ruudulla minuuttien ja sekuntien lisäksi tunnit.
        if (tunnit > 0)

            // Palautetaan arvoksi string.Format-funktiolla muotoiltu teksti. {}-sulkeiden sisällä oleva ensimmäinen luku
            // tarkoittaa monennesko parametri syötetään tähän kohtaan. Sen perässä oleva :D2 pakottaa luvun kahden luvun kokoiseksi,
            // eli jos minuutteja on kulunut vain 5, näyttää se sen muodossa 05.
            return string.Format("{0:D2}:{1:D2}:{2:D2}", tunnit, minuutit, sekunnit);

        // Jos pelaaja on pelannut alle tunnin, näytetään vain minuutit ja sekunnit.
        return string.Format("{0:D2}:{1:D2}", minuutit, sekunnit);
    }
}
