﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

// Tarvitsemme Unityn UI-resurssit käsitelläksemme UI-komponentteja
using UnityEngine.UI;

// Tarvitsemme Unityn SceneManagement-resurssit, koska aloitusvalikko lataa tasoja.
using UnityEngine.SceneManagement;

public class Aloitusvalikko : MonoBehaviour {

    // Näyttääksemme valikossa pelaajan ennätyksen, tarvitsemme viittauksen kyseiseen tekstiin.
    public Text ennätysPisteet;
    
	void Start () {
        // Asetetaan ennätystekstin tekstiksi ladatut pisteet. Koska pisteet ovat kokonaislukuja, pitää se muuttaa tekstiksi
        // ToString-funktiolla.
        ennätysPisteet.text = LataaPisteet().ToString();
	}

    // Tämän funktion kutsuu valikon pelaa-painike.
    public void Pelaa()
    {
        // Ladataan Maailma-taso, jolloin peli alkaa.
        SceneManager.LoadScene("Maailma");
    }

    // Tämän funktion kutsuu valikon lopeta-painike.
    public void Lopeta()
    {
        // Application.Quit-funktio sulkee pelin. PlayerPrefs-arvot tallennetaan tällöin levylle.
        // Huomaa, että Quit-funktio ei toimi editorissa, vaan buildatussa versiossa.
        Application.Quit();
    }

    // Tämä funktio lataa ennätyspisteet PlayerPrefs-luokasta GetInt-funktiolla.
    public int LataaPisteet()
    {
        return PlayerPrefs.GetInt("Pisteet");
    }

}
