﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

// Tarvitsemme Unityn SceneManagement-resurssit, koska pysäytysvalikko lataa tasoja.
using UnityEngine.SceneManagement;

public class Pysäytysvalikko : MonoBehaviour {

    // Tähän muuttujaan tallennamme viittauksen pysäytysvalikko-objektiin, jota käytämme valikon näyttämiseen ja piilottamiseen.
    public GameObject pysäytysvalikko;
    
	void Update () {
        // Mikäli pelaaja painaa ESC-näppäintä, tahdomme näyttää tai piilottaa pysäytysvalikon.
        if (Input.GetKeyDown(KeyCode.Escape))
        {
            // Muuttuja avaa sisältää tiedon siitä, pitäisikö valikko avata.
            // activeInHierarchy palauttaa tiedon siitä, onko objekti asetettu päälle hierarkiassa.
            // Jos tämä on tosi, avaa-muuttuja saa arvon epätosi (koska ! edessä), ja tiedämme sitten sulkea valikon. 
            bool avaa = !pysäytysvalikko.activeInHierarchy;

            // Asetetaan pysäytysvalikko aktiiviseksi tai inaktiiviseksi riippuen avaa-muuttujan arvosta, eli siitä onko valikko jo auki.
            pysäytysvalikko.SetActive(avaa);

            // Lopuksi pysäytetään peli. Jos avaa on tosi, arvoksi tulee 0, muutoin 1.
            Time.timeScale = avaa ? 0 : 1;
        }
	}

    // Tämän funktion kutsuu valikon jatka-painike.
    public void Jatka()
    {
        // Piilotetaan valikko.
        pysäytysvalikko.SetActive(false);

        // Jatketaan peliä.
        Time.timeScale = 1;
    }

    // Tämän funktion kutsuu valikon aloita alusta-painike.
    public void AloitaAlusta()
    {
        // Jos pelaaja sai uuden ennätyksen, ehto toteutuu.
        if (Pisteet.instanssi.PisteidenMäärä() > PlayerPrefs.GetInt("Pisteet"))
        
            // Asetetaan PlayerPrefs-luokan "Pisteet"-kokonaislukuarvoksi uusi pisteiden määrä.
            PlayerPrefs.SetInt("Pisteet", Pisteet.instanssi.PisteidenMäärä());

        // Ladataan jo auki oleva taso uudelleen, jolloin peli alkaa alusta.
        SceneManager.LoadScene("Maailma");

        // Muistetaan laittaa timeScale takaisin ykköseen, jottei peli jää pysähdyksiin.
        Time.timeScale = 1;
    }

    // Tämän funktion kutsuu valikon aloitusvalikko-painike.
    public void Aloitusvalikko()
    {
        // Jos pelaaja sai uuden ennätyksen, ehto toteutuu.
        if (Pisteet.instanssi.PisteidenMäärä() > PlayerPrefs.GetInt("Pisteet"))
        
            // Asetetaan PlayerPrefs-luokan "Pisteet"-kokonaislukuarvoksi uusi pisteiden määrä.
            PlayerPrefs.SetInt("Pisteet", Pisteet.instanssi.PisteidenMäärä());

        // Ladataan Aloitusvalikko-taso.
        SceneManager.LoadScene("Aloitusvalikko");

        // Muistetaan asettaa timeScale takaisin ykköseen, jolloin peli ei jää pysäytetyksi, jos pelaaja jatkaa pelaamista.
        Time.timeScale = 1;
    }

}
