﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class RobotinSeuranta : MonoBehaviour
{

    // Kohteen sijaintia maailmassa hyödyntääksemme valitsemme Transform-tyypin muuttujallemme.
    // Arvon voi asettaa inspektorista, koska tämä muuttuja on julkinen.
    public Transform kohde;

    // Etäisyys, jonka kamera pitää kohteeseen.
    Vector3 etäisyys;

    // Start-funktio on Unity-pelimoottorin kutsuma ja se kutsutaan
    // kun tämä skripti ensimmäisen kerran tulee päälle, yleensä pelin alussa.
    void Start()
    {
        // Tallennetaan etäisyys-muuttujaan kameran ja kohteen välinen vektori.
        // Oikea suunta tälle vektorille saadaan vähentämällä kameran sijainnista kohteen sijainti.
        etäisyys = transform.position - kohde.position;
    }

    // Huomaa: Update-funktion sijasta käytämme LateUpdate-funktiota. LateUpdatea käyttämällä
    // vältämme mahdollisen kameran 'tökkimisen' sen liikkuessa. Kuten Update, LateUpdate kutsutaan joka kerta kun
    // näytölle piirretään kuva. Jos peli pyörii 60 kuvaa sekunnissa, kutsutaan tämä funktio 60 kertaa sekunnin aikana.
    void LateUpdate()
    {
        // Asetetaan kameran sijainniksi kohteen sijainti ja lisätään siihen pelin alussa tallennettu etäisyys-vektori.
        transform.position = kohde.position + etäisyys;
    }
}
